package com.docus.server.infrastructure.dao.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.docus.core.util.Func;
import com.docus.infrastructure.core.db.dao.impl.BaseDaoImpl;
import com.docus.infrastructure.web.request.SearchDTO;
import com.docus.infrastructure.web.response.PageResult;
import com.docus.server.entity.scheduling.management.SchCollector;
import com.docus.server.infrastructure.dao.ISchCollectorDao;
import com.docus.server.infrastructure.mapper.SchCollectorMapper;
import com.github.pagehelper.PageHelper;
import org.springframework.stereotype.Repository;

import java.util.Date;
import java.util.List;

/**
 * 采集器管理 数据访问实现类
 *
 * @author AutoGenerator
 * @since 2023-07-15
 */
@Repository
public class SchCollectorDaoImpl extends BaseDaoImpl<SchCollectorMapper, SchCollector> implements ISchCollectorDao {

    /**
     * 按主键查询
     *
     * @param id 主键Id
     * @return 实体
     */
    @Override
    public SchCollector findById(String id) {
        return super.findById(id);
    }

    /**
     * 新增
     *
     * @param schCollector 编辑参数
     * @return 成功或失败
     */
    @Override
    public boolean add(SchCollector schCollector) {
        return super.save(schCollector);
    }

    /**
     * 编辑
     *
     * @param schCollector 编辑参数
     * @return 成功或失败
     */
    @Override
    public boolean edit(SchCollector schCollector) {
        return super.updateById(schCollector);
    }

    /**
     * 批量删除
     *
     * @param ids 主键ids
     * @return 成功或失败
     */
    @Override
    public int delete(List<Long> ids) {
        return super.deleteByIds(ids);
    }

    /**
     * 关键字搜索
     *
     * @param searchDTO 搜索参数
     * @return 分页列表
     */
    @Override
    public PageResult<SchCollector> search(SearchDTO searchDTO) {
        //分页
        PageHelper.startPage(searchDTO.getPageNum(), searchDTO.getPageSize());
        LambdaQueryWrapper<SchCollector> query = Wrappers.lambdaQuery();
        //时间范围，默认按createTime
        if (searchDTO.getBeginTime() != null) {
            query.ge(SchCollector::getCreateTime, searchDTO.getBeginTime());
        }
        if (searchDTO.getEndTime() != null) {
            Date endTime = searchDTO.getEndTime();
            query.le(SchCollector::getCreateTime, endTime);
        }

        Object collectorId = searchDTO.getParams("collectorId");
        if (Func.isNotEmpty(collectorId)) {
            query.eq(SchCollector::getCollectorId, collectorId);
        }

        //默认createTime倒序排序
        query.orderByDesc(SchCollector::getCreateTime);
        List<SchCollector> list = super.find(query);
        return new PageResult<>(list);
    }

}
